diff -ruN ../nakedmudv2.7/src/parse.h src/parse.h
--- ../nakedmudv2.7/src/parse.h	Wed Dec 31 17:00:00 1969
+++ src/parse.h	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,116 @@
+#ifndef PARSE_H
+#define PARSE_H
+//*****************************************************************************
+//
+// parse.h
+//
+// Player commands usually each take their own strict format. For instance,
+// the give command takes the format give <player> <object>. However, having to
+// parse out these arguments by hand in each command is a bit of a hassle and
+// something we can probably cut out most of the legwork for. That's what the
+// functions in this header are designed to do.
+//
+//*****************************************************************************
+
+//
+// format is a space-separated list of arguments to be parsed out. The following
+// argument types are valid:
+//   ch             someone the looker can see, with the specified keyword.
+//   obj            something the looker can see, with the specified keyword
+//   room           a room in the game with the specified key
+//   exit           an exit/dir the looker can see, with the specified keyword
+//   word           any single word (ends at whitespace or \0)
+//   int            any integer value
+//   double         any double value
+//   bool           any boolean value (true, false, yes, no, 0, 1)
+//   string         all text left to be parsed, up until the \0 delimeter
+//
+// Any arguments following a | are optional. They are things that will be parsed
+// if args has enough arguments in it, but which will be left null otherwise.
+//
+// If multiple types can plausibly be returned (e.g. trying to close a door or
+// an exit), the types can be enclosed in { and } and separated by spaces. If
+// the { } syntax is supplied, an additional integer pointer must be supplied 
+// to parse_args. It will contain the type of thing parsed, as represented by 
+// one of these definitions:
+#define PARSE_NONE                  -1
+#define PARSE_EXIT                   0
+#define PARSE_CHAR                   1
+#define PARSE_OBJ                    2
+#define PARSE_ROOM                   3
+#define PARSE_STRING                 4
+#define PARSE_DOUBLE                 5
+#define PARSE_INT                    6
+#define PARSE_BOOL                   7
+// Types will be checked by the order they are provided in. So, for instance
+// {room ch obj} would check for a room first, then a ch, and otherwise an obj.
+// NOTE: Using double, integer, and boolean values in the { } syntax is frowned
+// upon, as assigning non-pointer values to points (which the other types must
+// be) can result in wacky and random errors. Stick to using exit, char, obj,
+// room, and word within the { } notation.
+//
+// Optional or mandatory 'flavor' syntax can be provided as well. For instance,
+// if you would like people to be able to put "the" in front of object names.
+// Mandatory 'flavor' syntax must be surrounded by < and >. Optional 'flavor'
+// syntax must be surrounded by [ and ].
+//
+// .room can be tagged to the end of chs and objs to specify that other 
+// chs/objs in the room are looked for.
+//
+// .world can be tagged to the end of chs and objs to specify that other
+// chs/objs in the world are looked for.
+//
+// .inv can be tagged to the end of objs to specify that objects in the person's
+// inventory are looked for.
+//
+// .eq can be tagged to the end of objs to specify that objects worn by the
+// character are looked for.
+//
+// .multiple can be tagged to the end of a ch, obj, or exit lookup. It 
+// signifies that multiple items might be returned. If the .multiple syntax is
+// supplied, an additional boolean pointer argument must be supplied to 
+// parse_args after the pointer to the thing to be assigned a value. After 
+// parse_args finishes, this boolean value will have true/false if a list was 
+// returned, or a single item. This argument must be supplied after any multi
+// type arguments (use of { and }) in the argument list.
+//
+// .noself can be tagged to the end of any ch lookup. It signifies that the
+// character cannot specify themselves as an argument. If it is used in
+// conjunction with .multiple, the looker will be taken out of any list 
+// returned.
+//
+// .invis_ok can be tagged to the end of any ch, obj, or exit lookup. It 
+// signifies that the normal constraint of being able to see the target is 
+// nullified.
+//
+// both ch and obj markers require at least ONE argument tagged to the end of
+// them, to specify where the are looked for (e.g. ch.room, obj.inv). A ch or
+// an obj by itself will not suffice.
+//
+// parse_args returns true/false if it succeeded or failed. If show_errors is
+// true, syntax and type errors and failures to find targets are reported to
+// the looker in a  player-friendly format. such as "could not find person, 
+// 'bob'" or "the room 'city_square@midgaard' does not exist!"
+//
+// ********************************* IMPORTANT *********************************
+//
+// IT IS THE DUTY OF THE USER TO FREE ANY LISTS RETURNED BY PARSE_ARGS. ALSO,
+// IF ANY WORDS OR STRINGS ARE QUERIED FOR, THE MEMORY PASSED IN AS args *WILL*
+// BE MANGLED BEYOND RECOGNITION TO PREVENT PEOPLE FROM ALSO HAVING TO FREE ANY
+// STRING VALUES RETURNED.
+//
+// ********************************* IMPORTANT *********************************
+//
+// examples:
+//   tell         ch.world.noself string
+//   close        [the] {exit obj.room.inv}
+//   goto         {room ch.world obj.world}
+//   remove       [the] obj.eq.multiple.invis_ok
+//   put          [the] obj.inv.multiple [in the] obj.room.inv
+//   give         [the] obj.inv.multiple [to] ch.room
+//   set          ch.world.multiple word string
+//   transfer     ch.world.multiple.noself | [to] room
+bool parse_args(CHAR_DATA *looker, bool show_errors, const char *cmd, 
+		char *args, const char *syntax, ...);
+
+#endif // PARSE_H
diff -ruN ../nakedmudv2.7/src/prototype.c src/prototype.c
--- ../nakedmudv2.7/src/prototype.c	Wed Dec 31 17:00:00 1969
+++ src/prototype.c	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,214 @@
+//*****************************************************************************
+//
+// prototype.c
+//
+// generic prototype datastructure for anything that can be generated with a
+// python script (e.g. object, room, character). Supports inheritance from
+// other prototypes.
+//
+//*****************************************************************************
+#include "mud.h"
+#include "utils.h"
+#include "prototype.h"
+#include "storage.h"
+#include "room.h"
+#include "character.h"
+#include "object.h"
+#include "world.h"
+#include "zone.h"
+#include "handler.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "scripts/scripts.h"
+#include "scripts/pychar.h"
+#include "scripts/pyroom.h"
+#include "scripts/pyobj.h"
+
+
+
+//*****************************************************************************
+// local datastructures, functions, and variables
+//*****************************************************************************
+struct prototype_data {
+  char       *key;
+  char   *parents;
+  bool   abstract;
+  BUFFER  *script;
+};
+
+
+
+//*****************************************************************************
+// implementation of prototype.h
+//*****************************************************************************
+PROTO_DATA *newProto(void) {
+  PROTO_DATA *data = malloc(sizeof(PROTO_DATA));
+  data->key      = strdup("");
+  data->parents  = strdup("");
+  data->abstract = TRUE;
+  data->script   = newBuffer(1);
+  return data;
+}
+
+void deleteProto(PROTO_DATA *data) {
+  if(data->key)     free(data->key);
+  if(data->parents) free(data->parents);
+  if(data->script)  deleteBuffer(data->script);
+  free(data);
+}
+
+void protoCopyTo(PROTO_DATA *from, PROTO_DATA *to) {
+  protoSetKey(to,      protoGetKey(from));
+  protoSetParents(to,  protoGetParents(from));
+  protoSetScript(to,   protoGetScript(from));
+  protoSetAbstract(to, protoIsAbstract(from));
+}
+
+PROTO_DATA *protoCopy(PROTO_DATA *data) {
+  PROTO_DATA *newproto = newProto();
+  protoCopyTo(data, newproto);
+  return newproto;
+}
+
+STORAGE_SET   *protoStore(PROTO_DATA *data) {
+  STORAGE_SET *set = new_storage_set();
+  store_string(set, "parents",  data->parents);
+  store_bool  (set, "abstract", data->abstract);
+  store_string(set, "script",   bufferString(data->script));
+  return set;
+}
+
+PROTO_DATA *protoRead(STORAGE_SET *set) {
+  PROTO_DATA *data = newProto();
+  protoSetParents(data,  read_string(set, "parents"));
+  protoSetAbstract(data, read_bool  (set, "abstract"));
+  protoSetScript(data,   read_string(set, "script"));
+  return data;
+}
+
+void protoSetKey(PROTO_DATA *data, const char *key) {
+  if(data->key) free(data->key);
+  data->key = strdupsafe(key);
+}
+
+void  protoSetParents(PROTO_DATA *data, const char *parents) {
+  if(data->parents) free(data->parents);
+  data->parents = strdupsafe(parents);
+}
+
+void   protoSetScript(PROTO_DATA *data, const char *script) {
+  bufferClear(data->script);
+  bufferCat(data->script, script);
+}
+
+void protoSetAbstract(PROTO_DATA *data, bool abstract) {
+  data->abstract = abstract;
+}
+
+const char *protoGetKey(PROTO_DATA *data) {
+  return data->key;
+}
+
+const char  *protoGetParents(PROTO_DATA *data) {
+  return data->parents;
+}
+
+bool protoIsAbstract(PROTO_DATA *data) {
+  return data->abstract;
+}
+
+const char   *protoGetScript(PROTO_DATA *data) {
+  return bufferString(data->script);
+}
+
+BUFFER *protoGetScriptBuffer(PROTO_DATA *data) {
+  return data->script;
+}
+
+bool protoRun(PROTO_DATA *proto, const char *type, void *pynewfunc, 
+	      void *protoaddfunc, void *protoclassfunc, void *me) {
+  // parse all of our parents
+  int i, num_parents = 0;
+  char     **parents = parse_keywords(proto->parents, &num_parents);
+  bool    parents_ok = TRUE;
+  for(i = 0; i < num_parents && parents_ok; i++) {
+    PROTO_DATA *parent = NULL;
+    // does our parent have a locale? If so, find it. If not, use ours
+    int separator_pos = next_letter_in(parents[i], '@');
+    if(separator_pos == -1)
+      parent = worldGetType(gameworld, type, 
+			    get_fullkey(parents[i],get_key_locale(proto->key)));
+    else
+      parent = worldGetType(gameworld, type, parents[i]);
+    if(parent == NULL || !protoRun(parent, type, pynewfunc, protoaddfunc, 
+				   protoclassfunc, me))
+      parents_ok = FALSE;
+    free(parents[i]);
+  }
+
+  // finish cleaning up our parent keys
+  for(; i < num_parents; i++)
+    free(parents[i]);
+  free(parents);
+
+  // did we encounter a problem w/ our parents?
+  if(parents_ok == FALSE)
+    return FALSE;
+
+  // now, do us
+  extern PyObject *newScriptDict();
+  extern void      start_script(PyObject *dict, const char *script);
+  PyObject *dict = restricted_script_dict();
+  PyObject *pyme = ((PyObject *(*)(void *))pynewfunc)(me);
+  if(protoaddfunc)
+    ((void (*)(void *, const char *))protoaddfunc)(me, protoGetKey(proto));
+  if(protoclassfunc)
+    ((void (*)(void *, const char *))protoclassfunc)(me, protoGetKey(proto));
+
+  PyDict_SetItemString(dict, "me", pyme);
+  run_script(dict, bufferString(proto->script), 
+	     get_key_locale(protoGetKey(proto)));
+  Py_DECREF(dict);
+  Py_DECREF(pyme);
+  return last_script_ok();
+}
+
+CHAR_DATA *protoMobRun(PROTO_DATA *proto) {
+  if(protoIsAbstract(proto))
+    return NULL;
+  CHAR_DATA *ch = newMobile();
+  char_to_game(ch);
+  if(!protoRun(proto, "mproto", newPyChar, charAddPrototype, charSetClass, ch)){
+    extract_mobile(ch);
+    ch = NULL;
+  }
+  return ch;
+}
+
+OBJ_DATA *protoObjRun(PROTO_DATA *proto) {
+  if(protoIsAbstract(proto))
+    return NULL;
+  OBJ_DATA *obj = newObj();
+  obj_to_game(obj);
+  if(!protoRun(proto, "oproto", newPyObj, objAddPrototype, objSetClass, obj)) {
+    extract_obj(obj);
+    obj = NULL;
+  }
+  return obj;
+}
+
+ROOM_DATA *protoRoomRun(PROTO_DATA *proto) {
+  if(protoIsAbstract(proto))
+    return NULL;
+  ROOM_DATA *room = newRoom();
+  room_to_game(room);
+  if(!protoRun(proto, "rproto", newPyRoom, roomAddPrototype,roomSetClass,room)){
+    extract_room(room);
+    room = NULL;
+  }
+  return room;
+}
diff -ruN ../nakedmudv2.7/src/prototype.h src/prototype.h
--- ../nakedmudv2.7/src/prototype.h	Wed Dec 31 17:00:00 1969
+++ src/prototype.h	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,41 @@
+#ifndef PROTOTYPE_H
+#define PROTOTYPE_H
+//*****************************************************************************
+//
+// prototype.h
+//
+// generic prototype datastructure for anything that can be generated with a
+// python script (e.g. object, room, character). Supports inheritance from
+// other prototypes.
+//
+//*****************************************************************************
+
+PROTO_DATA    *newProto(void);
+void        deleteProto(PROTO_DATA *data);
+void        protoCopyTo(PROTO_DATA *from, PROTO_DATA *to);
+PROTO_DATA   *protoCopy(PROTO_DATA *data);
+STORAGE_SET *protoStore(PROTO_DATA *data);
+PROTO_DATA   *protoRead(STORAGE_SET *set);
+bool           protoRun(PROTO_DATA *proto, const char *type, void *pynewfunc, 
+			void *protoaddfunc, void *protoclassfunc, void *me);
+CHAR_DATA  *protoMobRun(PROTO_DATA *proto);
+OBJ_DATA   *protoObjRun(PROTO_DATA *proto);
+ROOM_DATA *protoRoomRun(PROTO_DATA *proto);
+
+
+//
+// setters
+void      protoSetKey(PROTO_DATA *data, const char *key);
+void  protoSetParents(PROTO_DATA *data, const char *parents);
+void   protoSetScript(PROTO_DATA *data, const char *script);
+void protoSetAbstract(PROTO_DATA *data, bool abstract);
+
+//
+// getters
+const char      *protoGetKey(PROTO_DATA *data);
+const char  *protoGetParents(PROTO_DATA *data);
+const char   *protoGetScript(PROTO_DATA *data);
+bool         protoIsAbstract(PROTO_DATA *data);
+BUFFER *protoGetScriptBuffer(PROTO_DATA *data);
+
+#endif // PROTOTYPE_H
diff -ruN ../nakedmudv2.7/src/races.c src/races.c
--- ../nakedmudv2.7/src/races.c	Sun Jul 31 17:13:53 2005
+++ src/races.c	Fri Oct  7 14:15:55 2005
@@ -9,8 +9,8 @@
 //*****************************************************************************
 
 #include "mud.h"
-#include "body.h"
 #include "utils.h"
+#include "body.h"
 
 #include "races.h"
 
@@ -38,8 +38,8 @@
 RACE_DATA *newRace(const char *name, const char *abbrev, BODY_DATA *body,
 		   bool pc_ok) {
   RACE_DATA *data = malloc(sizeof(RACE_DATA));
-  data->name   = strdup(name ? name : "");
-  data->abbrev = strdup(abbrev ? abbrev : "");
+  data->name   = strdupsafe(name);
+  data->abbrev = strdupsafe(abbrev);
   data->body   = body;
   data->pc_ok  = pc_ok;
   return data;
